module MediaWiki.API.Query.Categories.Import where

import MediaWiki.API.Types
import MediaWiki.API.Utils
import MediaWiki.API.Query.Categories

import Text.XML.Light.Types

import Control.Monad
import Data.Maybe

stringXml :: String -> Either (String,[{-Error msg-}String]) CategoriesResponse
stringXml s = parseDoc xml s

xml :: Element -> Maybe CategoriesResponse
xml e = do
  guard (elName e == nsName "api")
  let es1 = children e
  p  <- pNode "query" es1
  let es2 = children p
  p  <- pNode "pages" es2
  let es = children p
  ps <- fmap (mapMaybe xmlPage) (fmap children $ pNode "page" es)
  let cont = pNode "query-continue" es1 >>= xmlContinue "categories" "clcontinue"
  return emptyCategoriesResponse{clPages=ps,clContinue=cont}

xmlPage :: Element -> Maybe (PageTitle,[PageTitle])
xmlPage e = do
   guard (elName e == nsName "page")
   let es = children e
   p <- pNode "categories" es
   let es1 = children p
   cs <- fmap (mapMaybe xmlCL) (fmap children $ pNode "cl" es1)
   let ns     = fromMaybe "0" $ pAttr "ns" p
   let tit    = fromMaybe ""  $ pAttr "title" p
   let mbpid  = pAttr "pageid" p
   return (emptyPageTitle{pgNS=ns,pgTitle=tit,pgMbId=mbpid}, cs)

xmlCL :: Element -> Maybe PageTitle
xmlCL e = do
   guard (elName e == nsName "cl")
   let ns     = fromMaybe "0" $ pAttr "ns" e
   let tit    = fromMaybe ""  $ pAttr "title" e
   let mbpid  = pAttr "pageid" e
   return emptyPageTitle{pgNS=ns,pgTitle=tit,pgMbId=mbpid}
